// Copyright (C) 2012-2014 Damir Korencic, Strahil Ristov
//
// This file is part of lzlex v0.1
//
// lzlex is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// lzlex is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lzlex.  If not, see <http://www.gnu.org/licenses/>.

#include "DebugException.h"

DebugException::DebugException(string* m)
: stackTrace( new StackTrace(1) )
{
    messages.push_back(m);
}

/** Utility constructor for easier and safer ASSERT_THROW macro declaration. */
DebugException::DebugException(string* m1, string *m2)
: stackTrace( new StackTrace(1) )
{
    messages.push_back(m1);
    messages.push_back(m2);
}

DebugException::~DebugException() {
    delete stackTrace;
    for (size_t i = 0; i < messages.size(); ++i)
        delete messages[i];
}

string DebugException::printStackTrace() const {
    return stackTrace->printStackTrace();
}

vector<string*> const & DebugException::getMessages() const {
    return messages;
}

/** If exception is caught and rethrown messages can be added in between. */
void DebugException::addMessage(string *m) {
    messages.push_back(m);
}



