// Copyright (C) 2012-2014 Damir Korencic, Strahil Ristov
//
// This file is part of lzlex v0.1
//
// lzlex is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// lzlex is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lzlex.  If not, see <http://www.gnu.org/licenses/>.

#ifndef STACKTRACE_H
#define	STACKTRACE_H

#include <execinfo.h>
#include <cstdlib>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

/** Get the stacktrace of the current execution point in the program.
 * This class is system dependent as it uses libc and libcwd framework.
 * Program must be compiled with -g and -DCWDEBUG and linked with -lcwd.
 */
class StackTrace {
public:

    StackTrace();
    StackTrace(int topPops);
    StackTrace(const StackTrace& orig);
    virtual ~StackTrace();

    string printStackTrace() const;

private:

    static const size_t maxStackSize = 1000;
    size_t size;

    vector<string> stack;

    void recordStackTrace(int pop);

};

#endif	/* STACKTRACE_H */


