// Copyright (C) 2012-2014 Damir Korencic, Strahil Ristov
//
// This file is part of lzlex v0.1
//
// lzlex is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// lzlex is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lzlex.  If not, see <http://www.gnu.org/licenses/>.

/**
 * Data passed to dictionaries and lexicons.
 */

#ifndef WORD_H
#define	WORD_H

#include <cstddef>

#include "node_array/types/symbol.h"

template <typename TSymbol>
class Word {
public:
    
    size_t getLength() { return 0; }
    TSymbol operator[](size_t index) {
        //TODO potreba za null_symbol?
        return zeroSymbol<TSymbol>();
    }

    virtual ~Word() { }

};

template <typename TSymbol>
class Word<TSymbol *> {
public:

    size_t getLength() {
        if (lengthCalculated) {
            return length;
        }
        else {
            calculateLength();
            return length;
        }
    }

    TSymbol operator[](size_t index) {
        return word[index];
    }

    Word(const TSymbol *w) {
        word = w;
        lengthCalculated = false;
    }

    virtual ~Word() { }

private:
    const TSymbol *word;
    size_t length;
    bool lengthCalculated;

    void calculateLength() {
        size_t len = 0;
        for (len = 0; word[len] != zeroSymbol<TSymbol>(); len++);
        length = len;
        lengthCalculated = true;
    }

};

#endif	/* WORD_H */


