// Copyright (C) 2012-2014 Damir Korencic, Strahil Ristov
//
// This file is part of lzlex v0.1
//
// lzlex is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// lzlex is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lzlex.  If not, see <http://www.gnu.org/licenses/>.

#include <string>

#include "compress/stats/StatCreator.hpp"
#include "node_array/vector_array/VectorArray.h"

using namespace std;

void testStats() {
   StatCreator<VectorArray<unsigned char, int> > cr(true, true, true);
   
   string allDicts = "english.txt german.txt french.txt russian.txt esp.dict polish.dict random.txt dimacs.txt pol_morph.txt wiki.txt";
   string largeDicts = "pol_morph.txt wiki.txt";
   string smallDicts = "english.txt german.txt french.txt russian.txt esp.dict polish.dict random.txt dimacs.txt";
   string statsOuputFolder = "../statistics";
   string dictFolder = "/data/dictionary_files";
   
   cr.makeStats("LCP", dictFolder, smallDicts , statsOuputFolder);
   //cr.makeStats("LCT", dictFolder, largeDicts , statsOuputFolder);
}

int main(int argc, char** argv) {    
    testStats();
}
