// Copyright (C) 2012-2014 Damir Korencic, Strahil Ristov
//
// This file is part of lzlex v0.1
//
// lzlex is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// lzlex is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lzlex.  If not, see <http://www.gnu.org/licenses/>.

#ifndef COMPACTARRAYUTILS_H
#define	COMPACTARRAYUTILS_H

/** Returns a code of node flags as a number in [0,3] ,
 * represented by (cow, eow) in binary. */
inline int nodeFlagsToInt(bool eow, bool cow) {
    int fl = 0;
    if (eow) fl += 1;
    if (cow) fl += 2;
    return fl;
}

/** Return eow bit from number representation of flags. */
inline bool intFlagsEow(int flags) {
    return (flags == 1 || flags == 3);
}

/** Return cow bit from number representation of flags. */
inline bool intFlagsCow(int flags) {
    return (flags == 2 || flags == 3);
}

#endif	/* COMPACTARRAYUTILS_H */


