// Copyright (C) 2012-2014 Damir Korencic, Strahil Ristov
//
// This file is part of lzlex v0.1
//
// lzlex is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// lzlex is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lzlex.  If not, see <http://www.gnu.org/licenses/>.

#include "na_utils.h"

/** Break a string to substrings separated with delimiter. */
vector<string> * breakByDelimiter(string const & str, const char delimiter) {
    vector<string>* tokens = new vector<string>;

    size_t i = 0; if (str[i] == delimiter) i++;
    string piece; piece.clear();

    for (; i < str.size(); ++i) {
        if (str[i] != delimiter) piece.push_back(str[i]);
        
        if (str[i] == delimiter || i == str.size() - 1) {
            tokens->push_back(piece);
            piece.clear();
        }
    }

    return tokens;
}

