// Copyright (C) 2012-2014 Damir Korencic, Strahil Ristov
//
// This file is part of lzlex v0.1
//
// lzlex is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// lzlex is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lzlex.  If not, see <http://www.gnu.org/licenses/>.

#include "char_symbol.h"

/** Decreased by one for compatibility with old C code, where
 * number stored in symbol field of pointers is full length of replaced
 * segment, not that length-1 (wich is enough because they must
 * match in first simbol). When converting to old format, these fields
 * must be increased by 1, so maxSymbols are decreased by 1. */

template <> char maxSymbol<char>() {
    return 126;
}

template <> char zeroSymbol<char>() {
    return (char)0;
}

template <> int symbolToInt<char>(char s) {
    return (int)s;
}



template <> unsigned char maxSymbol<unsigned char>() {
    return 254;
}

template <> unsigned char zeroSymbol<unsigned char>() {
    return (unsigned char)0;
}

template <> int symbolToInt<unsigned char>(unsigned char s) {
    return (int)s;
}
