// Copyright (C) 2012-2014 Damir Korencic, Strahil Ristov
//
// This file is part of lzlex v0.1
//
// lzlex is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// lzlex is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lzlex.  If not, see <http://www.gnu.org/licenses/>.

#include "BitSequenceArraySer.h"
#include "serialization/SerializationUtils.h"
#include <cassert>

/** Serializes BitSequenceArray to output stream. */
void BitSequenceArraySer::arrayToStream(BitSequenceArray const & array, ostream& stream) {
    // write integer members
    SerializationUtils::integerToStream(array.numOfBlocks, stream);
    SerializationUtils::integerToStream(array.numOfSequences, stream);
    SerializationUtils::integerToStream(array.bitsPerSequence, stream);
    
    // write the array
    stream.write(array.getBlocks(), array.getNumOfBlocks());
}

//TODO make the method write directly to an array
/** Deserializes BitSequenceArray from input stream. */
void BitSequenceArraySer::arrayFromStream(BitSequenceArray &array, istream& stream) {
    array.freeBlocks();

    // read integer members
    array.numOfBlocks = SerializationUtils::integerFromStream<size_t>(stream);
    array.numOfSequences = SerializationUtils::integerFromStream<size_t>(stream);
    array.bitsPerSequence = SerializationUtils::integerFromStream<size_t>(stream);

    // read the array
    array.allocateBlocks();
    stream.read(array.blocks, array.numOfBlocks);    
}

