// Copyright (C) 2012-2014 Damir Korencic, Strahil Ristov
//
// This file is part of lzlex v0.1
//
// lzlex is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// lzlex is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lzlex.  If not, see <http://www.gnu.org/licenses/>.

#include <iomanip>

#include "etimer.h"

clock_t getNowTime() {
    struct tms buf;
    times(&buf);
    return buf.tms_utime;
    //return clock();
}

void printNowTime(string message) {    
    clock_t time = getNowTime();
    if (message.length() != 0) {
        cout << message << " : " << setprecision(7) << time << endl;
    }
    else {
        cout << setprecision(7) << time << endl;
    }
}

long getTicks() {
    return sysconf(_SC_CLK_TCK);
//    return CLOCKS_PER_SEC; 
}

void startEvent(string eventName) {            
     clock_t t = getNowTime();
     events[eventName].start = t;
     events[eventName].end = t - 1;
}

void endEvent(string eventName) {
     clock_t t = getNowTime();
     events[eventName].end = t;
}

void printEvents() {
    map<string, TRange>::iterator it;
    for (it = events.begin(); it != events.end(); ++it) {
        TRange rng = it->second;
        double time =  ((double)(rng.end - rng.start)) / getTicks();
        cout << it->first << ": " << setprecision(7) << time << endl;
    }
}

double getEventTime(string event) {
    TRange rng = events[event];
    return ((double)(rng.end - rng.start)) / getTicks();
}

void clearEvents() {
    events.clear();
}

