// Copyright (C) 2012-2014 Damir Korencic, Strahil Ristov
//
// This file is part of lzlex v0.1
//
// lzlex is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// lzlex is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lzlex.  If not, see <http://www.gnu.org/licenses/>.

#ifndef TIMER_H
#define	TIMER_H

#include <map>
#include <string>
#include <ctime>
#include <iostream>
#include <sys/times.h>
#include <unistd.h>

using namespace std;

struct TRange {
    TRange(): start(0), end(0) {}

    clock_t start;
    clock_t end;
};

static map<string, TRange> events;

void startEvent(string eventName);
void endEvent(string eventName);

double getEventTime(string event);

void printEvents();
void clearEvents();

void printNowTime(string message="");
static clock_t getNowTime();
static long getTicks();

#endif	/* TIMER_H */


