// Copyright (C) 2012-2014 Damir Korencic, Strahil Ristov
//
// This file is part of lzlex v0.1
//
// lzlex is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// lzlex is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lzlex.  If not, see <http://www.gnu.org/licenses/>.

#ifndef PROPERTY_MAP_H
#define	PROPERTY_MAP_H

#include <map>
#include <string>
#include <sstream>

/** Global map for algorithms to pass the values
 * to execution and reporting classes. */

using namespace std;

static map<string, string> props;

template <typename T> 
void setProperty(string name, T value) {
    stringstream ss;
    ss << value;
    props[name] = ss.str();
}

bool propertyExists(string name);

template <typename T> 
T getProperty(string name) {
    if (props.count(name) == 0) return 0;
    stringstream ss(props[name]);
    T value;
    ss >> value;
    return value;
}


#endif	/* PROPERTY_MAP_H */


