// Copyright (C) 2012-2014 Damir Korencic, Strahil Ristov
//
// This file is part of lzlex v0.1
//
// lzlex is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// lzlex is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lzlex.  If not, see <http://www.gnu.org/licenses/>.

#ifndef REGEX_H
#define	REGEX_H

#include "node_array/types/symbol.h"

/** Fills the result with part of the word before '*', returns
 * true if word is of correct form which is string of symbols and than
 * optionally a '*' */
template <typename TSymbol>
bool getPrefixBeforeStar(TSymbol const * word, TSymbol *result) {
    size_t i;
    bool star = false;
    for (i = 0; word[i] != zeroSymbol<TSymbol>(); ++i) {
        if (word[i] == '*') break;
        result[i] = word[i];
    }
    result[i] = zeroSymbol<TSymbol>();

    if (word[i] == '*') {
        if (word[i+1] == zeroSymbol<TSymbol>()) return true;
        else return false;
    }
    else return true;
}

#endif	/* REGEX_H */


