// Copyright (C) 2012-2014 Damir Korencic, Strahil Ristov
//
// This file is part of lzlex v0.1
//
// lzlex is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// lzlex is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lzlex.  If not, see <http://www.gnu.org/licenses/>.

SMALL_DICT_SET="english.txt german.txt french.txt";
ALL_DICT='english.txt german.txt french.txt russian.txt esp.dict polish.dict random.txt dimacs.txt pol_morph.txt wiki.txt';
DDS="russian.txt polish.dict"
SMALL_DICT='english.txt german.txt french.txt russian.txt esp.dict polish.dict random.txt dimacs.txt';
DICT_FOLDER='/data/rudjer/code/lzt/dictionary_files/';
LARGE_DICT='pol_morph.txt wiki.txt'
LZLEX_COMMAND='./lzlex'

for dict in $SMALL_DICT; 
do
	lex_file=$dict'.lzl'
	dict=$DICT_FOLDER$dict;
	echo '--------- starting dict: '$dict' ... ';
	# compress dictionary
	eval 'rm '$lex_file;
	ccommand=$LZLEX_COMMAND' c  -i '$dict' -l '$lex_file;
	eval $ccommand;
	# test search 
	scommand=$LZLEX_COMMAND' s  -l '$lex_file' -s \* > output.txt';
	eval $scommand;
	echo 'cmp dict with * search on compressed lexicon';
	eval 'cmp '$dict' output.txt';
	# test intersect 
	eval 'rm output.txt';
	icommand=$LZLEX_COMMAND' i  -l '$lex_file' -i '$dict' > output.txt';
	echo $icommand;
	eval $icommand;
	echo 'cmp dict with intersect with compressed lexicon';
	eval 'cmp '$dict' output.txt';
	echo '--------- finished '$dict' ';
	echo;
done
