DICT_FOLDER='dictionary_files/';
DICT_SET="english.txt german.txt french.txt";
LZLEX_COMMAND='./lzlex'

echo;

for dict in $DICT_SET; 
do
	lex_file=$dict'.lzl'
	dict=$DICT_FOLDER$dict;
	echo '**** Dictionary: '$dict' ... ****';
	echo;
	# compress dictionary
	# remove dictionary file in case it exists
	eval 'rm '$lex_file;
	ccommand=$LZLEX_COMMAND' c  -i '$dict' -l '$lex_file;
	echo 'compressing...';
	echo $ccommand;
	eval $ccommand;
	echo;
	# test search 
	scommand=$LZLEX_COMMAND' s  -l '$lex_file' -s \* > output.txt';
	echo 'listing all the files in compressed dictionary to output.txt'
	echo $scommand;
	eval $scommand;
	echo 'compare output and original dictionary';
	echo 'cmp '$dict' output.txt';
	eval 'cmp '$dict' output.txt';
	echo;
	# test intersect 
	eval 'rm output.txt';
	icommand=$LZLEX_COMMAND' i  -l '$lex_file' -i '$dict' > output.txt';
	echo 'intersect compressed dicitonary with original dictionary'
	echo $icommand;
	eval $icommand;
	echo 'compare output and original dictionary';
	echo 'cmp '$dict' output.txt';
	eval 'cmp '$dict' output.txt';
	echo;
	echo 'finished '$dict;
	eval 'rm '$lex_file;
	echo;
	echo;
done
eval 'rm output.txt';
